# coding: utf-8
import datetime
import autopath
from os.path import join
import subprocess
from copy import copy
from bson.objectid import ObjectId
import logging
import ldb

from eoleaaf.config import domainnames, commonnames
domainnames['00000001'] = 'file.domseth.ac-test.fr'
commonnames['00000001'] = 'etb1'
from eoleaaf.aaf import reset_db
from eoleaaf.util import db
from eoleaaf.parseaaf import main
#from eoleaaf.parsedelta import main as main_delta
import eoleaaf.config
eoleaaf.config.profile_type = 'none'
from eoleaaf.sambatranslator import erase_db
from eoleaaf import sambatranslator

# get BASEDN and AD_REALM
exec(open('/etc/eole/samba4-vars.conf').read())

data = join(autopath.HERE, 'data', '20170704', 'moveuser')

data_complet = join(data, 'aaf-complet')
data_complet_maj = join(data, 'aaf-complet-maj')

def setup_function(module, ):
    reset_db()
    erase_db()


eleve = {u"ENTPersonJointure": "14357",
         u"ENTEleveStructRattachId": "436201",
         u"ENTPersonDateNaissance": "28/11/1914",
         u"ENTPersonNomPatro": "DELACOURT",
         u"sn": "DELACOURT",
         u"ENTPersonLogin": "albertine.delacourt02",
         u'FieldActionType': 'DELTAMOVE_DONE',
         u'FieldModifiedStatus': 1,
         u'UserType': "eleve",
         u"givenName": "Albertine",
         u"ENTPersonAutresPrenoms": [u"Albertine", u"Pauline"],
         u"personalTitle": "Mme.",
         u"ENTElevePersRelEleve1": '',
         u"ENTEleveQualitePersRelEleve1": '',
         u"ENTElevePersRelEleve2": '',
         u"ENTEleveQualitePersRelEleve2": '',
         u"ENTElevePersRelEleve": [u"994845$1$0$2$1$0", u"994846$2$1$1$1$0"],
         u"ENTEleveBoursier": "O",
         u"ENTEleveRegime": "EXTERNE LIBRE",
         u"ENTEleveTransport": "N",
         u"ENTEleveStatutEleve": "SCOLAIRE",
         u"ENTEleveMEF": "21220008110",
         u"ENTEleveLibelleMEF": "T-STL SC.PHYS.CHIM. EN LABORATOIRE",
         u"ENTEleveNivFormation": "TERMINALE GENERALE & TECHNO YC BT",
         u"ENTEleveFiliere": "TERMINALE TECHNOLOGIQUE",
         u"ENTEleveEnseignements": [u"PHILOSOPHIE", u"CHIMIE, BIOCHIMIE, SCIENCES DU VIVANT", u"ENSEIGNEMENT TECHNOLOGIQUE EN LV1", u"SCIENCES PHYSIQUES ET CHIMIQUES EN LABO.", u"VIE DE CLASSE", u"ACCOMPAGNEMENT PERSONNALISE", u"ANGLAIS LV1", u"EDUCATION PHYSIQUE ET SPORTIVE", u"ESPAGNOL LV2", u"MATHEMATIQUES", u"PHYSIQUE-CHIMIE"],
         u"ENTEleveCodeEnseignements": ["010300", u"308600"],
         u"ENTEleveGroupes": [],
         u"gecos": "Albertine DELACOURT",
         u"homedirectory": None,
         u"profilepath":   None,
         }


eleve_ad_toplevel = {
        "dn": ['CN=albertine.delacourt02,CN=Users,{}'.format(BASEDN)],
        "objectClass": ['top', 'ENTPerson', 'Eleves', 'sambaSamAccount', 'shadowAccount', 'posixAccount', 'ENTEleve', 'person', 'organizationalPerson', 'user', 'inetOrgPerson'],
        "cn": ['albertine.delacourt02'],
        "givenName": ['Albertine'],
        "instanceType": ['4'],
        "displayName": ['Albertine DELACOURT'],
        "sn": ['DELACOURT'],
        "uid": ['albertine.delacourt02'],
        "ENTPersonLogin": ['albertine.delacourt02'],
        "personalTitle" : ['Mme.'],
        "Divcod": ['etb1_t_stl'],
        "Meflcf": ['etb1_terminale_generale_techno_yc_bt'],
        "name": ['albertine.delacourt02'],
        "badPwdCount": ['0'],
        "codePage": ['0'],
        "countryCode": ['0'],
        "badPasswordTime": ['0'],
        "lastLogoff": ['0'],
        "lastLogon": ['0'],
        "primaryGroupID": ['513'],
        "logonCount": ['0'],
        "sAMAccountName": ['albertine.delacourt02'],
        "userPrincipalName": ['albertine.delacourt02@{}'.format(AD_REALM)],
        "objectCategory": ['CN=Person,CN=Schema,CN=Configuration,{}'.format(BASEDN)],
        "gecos": ['Albertine DELACOURT'],
        "userAccountControl": ['512'],
        "homeDrive": ['U:'],
        "loginShell": ['/bin/false'],
        "memberOf": ['CN=eleves,CN=Users,{}'.format(BASEDN), 'CN=00000002_eleves,CN=Users,{}'.format(BASEDN), 'CN=00000002,CN=Users,{}'.format(BASEDN), 'CN=00000002_t_stl,CN=Users,{}'.format(BASEDN)],
        "distinguishedName": ['CN=albertine.delacourt02,CN=Users,{}'.format(BASEDN)],
        "homeDirectory": ['\\\\FILE.DOMSETH.AC-TEST.FR\\albertine.delacourt02\\perso'],
        "profilePath":   ['\\\\FILE.DOMSETH.AC-TEST.FR\\albertine.delacourt02\\profil'],
        }

eleve_ad_groupsplit = copy(eleve_ad_toplevel)
eleve_ad_groupsplit['dn'] = ['CN=albertine.delacourt02,CN=Users,{}'.format(BASEDN)]
eleve_ad_groupsplit['memberOf'] = ['CN=eleves,OU=Group,{}'.format(BASEDN), 'CN=00000002_eleves,OU=00000002,OU=Group,{}'.format(BASEDN), 'CN=00000002,OU=00000002,OU=Group,{}'.format(BASEDN), 'CN=00000002_t_stl,OU=00000002,OU=Group,{}'.format(BASEDN)]
eleve_ad_groupsplit['distinguishedName'] = eleve_ad_groupsplit['dn']

eleve_ad_split = copy(eleve_ad_toplevel)
eleve_ad_split['dn'] = ['CN=albertine.delacourt02,OU=00000002,{}'.format(BASEDN)]
eleve_ad_split['memberOf'] = ['CN=eleves,CN=Users,{}'.format(BASEDN), 'CN=00000002_eleves,OU=00000002,{}'.format(BASEDN), 'CN=00000002,OU=00000002,{}'.format(BASEDN), 'CN=00000002_t_stl,OU=00000002,{}'.format(BASEDN)]
eleve_ad_split['distinguishedName'] = eleve_ad_split['dn']

eleves = {u'21220008110': eleve}

eleves_ad_toplevel = {u'21220008110': eleve_ad_toplevel}
eleves_ad_groupsplit = {u'21220008110': eleve_ad_groupsplit}
eleves_ad_split = {u'21220008110': eleve_ad_split}


prof = {
    u"ENTPersonJointure": "163",
    u"ENTPersonDateNaissance": "06/01/1918",
    u"ENTPersonNomPatro": "DELMARE",
    u"ENTPersonLogin": "ghislaine.delmare01",
    u'FieldActionType': 'DELTAMOVE_DONE',
    u'FieldModifiedStatus': 1,
    u'UserType': 'enseignant',
    u"sn": "DELMARE",
    u"givenName": "Ghislaine",
    u"personalTitle": "Mme",
    u"mail": "ghislaine.delmare@ac-test.fr",
    u"ENTAuxEnsCategoDiscipline": "LANGUES VIVANTES",
    u"ENTAuxEnsDisciplinesPoste": "ANGLAIS",
    u"PersEducNatPresenceDevantEleves": "O",
    u"gecos": "Ghislaine DELMARE",
    u"homedirectory": None,
    u"profilepath":   None,
    }


prof_ad = {
        "dn": ['CN=ghislaine.delmare01,CN=Users,{}'.format(BASEDN)],
        "objectClass": ['top', 'ENTAuxEnseignant', 'ENTPerson', 'administrateur', 'sambaSamAccount', 'shadowAccount', 'posixAccount', 'person', 'organizationalPerson', 'user', 'inetOrgPerson'],
        "cn": ['ghislaine.delmare01'],
        "uid": ['ghislaine.delmare01'],
        "instanceType": ['4'],
        "name": ['ghislaine.delmare01'],
        "badPwdCount": ['0'],
        "codePage": ['0'],
        "countryCode": ['0'],
        "badPasswordTime": ['0'],
        "sn": [u'DELMARE'],
        "personalTitle": ['Mme'],
        "ENTPersonLogin": ['ghislaine.delmare01'],
        "Divcod": ["etb1_4e3"],
        "typeadmin": ['2'],
        "lastLogoff": ['0'],
        "lastLogon": ['0'],
        "primaryGroupID": ['513'],
        "logonCount": ['0'],
        "sAMAccountName": ['ghislaine.delmare01'],
        "userPrincipalName": ['ghislaine.delmare01@{}'.format(AD_REALM)],
        "objectCategory": ['CN=Person,CN=Schema,CN=Configuration,{}'.format(BASEDN)],
        "userAccountControl": ['512'],
        "memberOf": ['CN=00000002,CN=Users,{}'.format(BASEDN), 'CN=00000002_professeurs,CN=Users,{}'.format(BASEDN), 'CN=professeurs,CN=Users,{}'.format(BASEDN), 'CN=00000002_anglais_lv1,CN=Users,{}'.format(BASEDN), 'CN=profs-00000002_4e3_a,CN=Users,{}'.format(BASEDN)],
        "givenName": ['Ghislaine'],
        "displayName": ['Ghislaine DELMARE'],
        "gecos": ['Ghislaine DELMARE'],
        "homeDrive": ['U:'],
        "loginShell": ['/bin/false'],
        "distinguishedName": ['CN=ghislaine.delmare01,CN=Users,{}'.format(BASEDN)],
        "homeDirectory": ['\\\\FILE.DOMSETH.AC-TEST.FR\\ghislaine.delmare01\\perso'],
        "profilePath":   ['\\\\FILE.DOMSETH.AC-TEST.FR\\ghislaine.delmare01\\profil'],
        }

prof_ad_groupsplit = copy(prof_ad)
prof_ad_groupsplit['dn'] = ['CN=ghislaine.delmare01,CN=Users,{}'.format(BASEDN)]
prof_ad_groupsplit['memberOf'] = ['CN=00000002,OU=00000002,OU=Group,{}'.format(BASEDN), 'CN=00000002_professeurs,OU=00000002,OU=Group,{}'.format(BASEDN), 'CN=professeurs,OU=Group,{}'.format(BASEDN), 'CN=00000002_anglais_lv1,OU=00000002,OU=Group,{}'.format(BASEDN), 'CN=profs-00000002_4e3_a,OU=00000002,OU=Group,{}'.format(BASEDN)]
prof_ad_groupsplit['distinguishedName'] = prof_ad_groupsplit['dn']

prof_ad_split = copy(prof_ad)
prof_ad_split['dn'] = ['CN=ghislaine.delmare01,OU=00000002,{}'.format(BASEDN)]
prof_ad_split['memberOf'] = ['CN=00000002,OU=00000002,{}'.format(BASEDN), 'CN=00000002_professeurs,OU=00000002,{}'.format(BASEDN), 'CN=professeurs,CN=Users,{}'.format(BASEDN), 'CN=00000002_anglais_lv1,OU=00000002,{}'.format(BASEDN), 'CN=profs-00000002_4e3_a,OU=00000002,{}'.format(BASEDN)]
prof_ad_split['distinguishedName'] = prof_ad_split['dn']

profs = {
        u'163': prof
        }

profs_ad_toplevel = {u'163': prof_ad}
profs_ad_groupsplit = {u'163': prof_ad_groupsplit}
profs_ad_split = {u'163': prof_ad_split}


administratif = {
    u"ENTPersonJointure": "34",
    u"ENTPersonDateNaissance": "04/09/1985",
    u"ENTPersonNomPatro": "THEODULE",
    u"ENTPersonLogin": "annie.dubled01",
    u'FieldActionType': 'DELTAUPDATE_DONE',
    u'FieldModifiedStatus': 1,
    u'UserType': 'administratif',
    u"sn": "DUBLED",
    u"givenName": "Annie",
    u"personalTitle": "Mme",
    u"mail": "Annie.Dubled@ac-test.fr",
    u"ENTPersonStructRattach": '',
    u"ENTAuxEnsMEF": '',
    u"ENTAuxEnsMatiereEnseignEtab": '',
    u"ENTAuxEnsClasses": '',
    u"ENTAuxEnsClassesMatieres": '',
    u"PersEducNatPresenceDevantEleves": "N",
    u"gecos": "Annie DUBLED",
    u"homedirectory": None,
    u"profilepath":   None,
}

administratifs = {'34': administratif}

administratif_ad_toplevel = {
        "dn": ['CN=annie.dubled01,CN=Users,{}'.format(BASEDN)],
        "objectClass": ['top', 'ENTAuxNonEnsEtab', 'ENTPerson', 'administratif', 'sambaSamAccount', 'shadowAccount', 'posixAccount', 'person', 'organizationalPerson', 'user', 'inetOrgPerson'],
        "cn": ['annie.dubled01'],
        "givenName": ['Annie'],
        "instanceType": ['4'],
        "displayName": ['Annie DUBLED'],
        "sn": ['DUBLED'],
        "uid": ['annie.dubled01'],
        "ENTPersonLogin": ['annie.dubled01'],
        "typeadmin": ['3'],
        "personalTitle" : ['Mme'],
        "name": ['annie.dubled01'],
        "badPwdCount": ['0'],
        "codePage": ['0'],
        "countryCode": ['0'],
        "badPasswordTime": ['0'],
        "lastLogoff": ['0'],
        "lastLogon": ['0'],
        "primaryGroupID": ['513'],
        "logonCount": ['0'],
        "sAMAccountName": ['annie.dubled01'],
        "userPrincipalName": ['annie.dubled01@{}'.format(AD_REALM)],
        "objectCategory": ['CN=Person,CN=Schema,CN=Configuration,{}'.format(BASEDN)],
        "gecos": ['Annie DUBLED'],
        "userAccountControl": ['512'],
        "memberOf": ['CN=administratifs,CN=Users,{}'.format(BASEDN), 'CN=00000002,CN=Users,{}'.format(BASEDN), 'CN=00000002_administratifs,CN=Users,{}'.format(BASEDN)],
        u'homeDrive': ['U:'],
        "loginShell": ['/bin/false'],
        "distinguishedName": ['CN=annie.dubled01,CN=Users,{}'.format(BASEDN)]
}

administratif_ad_groupsplit = copy(administratif_ad_toplevel)
administratif_ad_groupsplit['memberOf'] = ['CN=00000002,OU=00000002,OU=Group,{}'.format(BASEDN), 'CN=00000002_administratifs,OU=00000002,OU=Group,{}'.format(BASEDN), 'CN=administratifs,OU=Group,{}'.format(BASEDN)]

administratif_ad_split = copy(administratif_ad_toplevel)
administratif_ad_split['memberOf'] = ['CN=00000002,OU=00000002,{}'.format(BASEDN), 'CN=00000002_administratifs,OU=00000002,{}'.format(BASEDN), 'CN=administratifs,CN=Users,{}'.format(BASEDN)]

administratifs_ad_toplevel = {'34': administratif_ad_toplevel}
administratifs_ad_groupsplit = {'34': administratif_ad_groupsplit}
administratifs_ad_split = {'34': administratif_ad_split}


def test_prof():
    ori_toplevel_ou_group = eoleaaf.config.toplevel_ou_group
    ori_toplevel_ou_user = eoleaaf.config.toplevel_ou_user
    for mode, profs_ad, SambaExport in [('toplevel', profs_ad_toplevel, sambatranslator.SambaToplevel), ('groupsplit', profs_ad_groupsplit, sambatranslator.SambaGroupSplit), ('split', profs_ad_split, sambatranslator.SambaSplit)]:
        if mode == 'toplevel':
            sambatranslator.toplevel_ou_group = ori_toplevel_ou_group
            sambatranslator.toplevel_ou_user = ori_toplevel_ou_user
        elif mode == 'groupsplit':
            sambatranslator.toplevel_ou_group = 'OU=Group'
            sambatranslator.toplevel_ou_user = ori_toplevel_ou_user
        else:  # mode == 'split'
            sambatranslator.toplevel_ou_group = ori_toplevel_ou_group
            sambatranslator.toplevel_ou_user = ori_toplevel_ou_user
        setup_function(None)
        objectid = 'ENTPersonStructRattach'
        relations = [(u'ENTAuxEnsMatiereEnseignEtab', ['etb1_ANGLAIS LV1']),
                     (u"ENTAuxEnsClasses", ["etb1_4E3", "etb1_5E2", "etb1_5E3", "etb1_5E4", "etb1_6E1", "etb1_6E2"]),
                     (u"ENTAuxEnsClassesPrincipal", ["etb1_4E3"]),
                     (u"ENTAuxEnsGroupes", ["etb1_4E3_A"]),
                     (u"ENTAuxEnsMEF", ["etb1_4EME", "etb1_4EME SECTION EUROPEENNE", "etb1_5EME", "etb1_6EME"]),
                     (u'ENTPersonFonctions', (['ENSEIGNEMENT'], ['ANGLAIS'])),
                     (u"ENTAuxEnsClassesMatieres", ["4E3", "5E2", "5E3", "5E4", "6E1", "6E2"]),
                     (u"ENTAuxEnsGroupesMatieres", ["4E3_A"]),
                     (u"ENTPersonStructRattachsOld", ["4E3_A"]),
                     ]
        keys = set(prof.keys()) | set([u"userPassword", u"_id", u'uid', u'FieldFromXMLImportActionDate', u'id', u'FieldToLDIFFExportActionDate']) | set([objectid])
        for relation in relations:
            keys |= set([relation[0]])
        log = logging.getLogger(__name__)
        #import complet AAF
        main(data_complet, False, allow_bulk=False, close=False)
        samba_import = SambaExport(log, debug=True)
        samba_import.run()
        #import delta AAF
        main(data_complet_maj, True, allow_bulk=False)
        samba_import = SambaExport(log, debug=True)
        samba_import.run()
        result = db.fetchall('user', 'UserType', 'enseignant')
        list_profs = list(profs)
        for res in result:
            idx = res['id']
            if idx not in profs.keys():
                continue
            list_profs.remove(idx)
            print ("professeur " + idx + ' en mode ' + mode )
            assert keys == set(res.keys())
            for key in prof.keys():
                assert res[key] == profs[idx][key], u"la valeur correspondant à : {} est différente".format(key)
            etab = res[objectid]
            assert isinstance(etab, ObjectId), u"{} n'est pas une relation".format(objectid)
            # we test what is in the AD
            filter_ = "(&(sAMAccountName=%s)(objectCategory=%s,%s))" % (ldb.binary_encode(res['ENTPersonLogin']),
                      "CN=Person,CN=Schema,CN=Configuration", samba_import.samdb.domain_dn())
            target = samba_import.samdb.search(base=samba_import.samdb.domain_dn(), scope=ldb.SCOPE_SUBTREE,
                                 expression=filter_)
            query_result = list(target)
            assert len(query_result) == 1
            list_keys = list(profs_ad[idx])
            for key, value in dict(query_result[0]).items():
                values = []
                if key in ['whenCreated', 'whenChanged', 'objectGUID', 'objectSid', 'accountExpires', 'sAMAccountType', 'pwdLastSet', 'uSNChanged', 'uSNCreated']:
                    continue
                if key not in list_keys:
                    raise Exception('extra key in Samba {} with value {}'.format(key, value))
                list_keys.remove(key)
                if isinstance(value, ldb.Dn):
                    values.append(str(value))
                else:
                    for i in value:
                        if i is not None:
                            i = str(i)
                        values.append(i)
                assert set(values) == set(profs_ad[idx][key]), u"valeurs différentes pour la clef : {}".format(key)
            assert not list_keys
        assert list_profs == []


def test_administratif():
    ori_toplevel_ou_group = eoleaaf.config.toplevel_ou_group
    ori_toplevel_ou_user = eoleaaf.config.toplevel_ou_user
    for mode, administratifs_ad, SambaExport in [('toplevel', administratifs_ad_toplevel, sambatranslator.SambaToplevel), ('groupsplit', administratifs_ad_groupsplit, sambatranslator.SambaGroupSplit), ('split', administratifs_ad_split, sambatranslator.SambaSplit)]:
        if mode == 'toplevel':
            sambatranslator.toplevel_ou_group = ori_toplevel_ou_group
            sambatranslator.toplevel_ou_user = ori_toplevel_ou_user
        elif mode == 'groupsplit':
            sambatranslator.toplevel_ou_group = 'OU=Group'
            sambatranslator.toplevel_ou_user = ori_toplevel_ou_user
        else:  # mode == 'split'
            sambatranslator.toplevel_ou_group = ori_toplevel_ou_group
            sambatranslator.toplevel_ou_user = ori_toplevel_ou_user
        setup_function(None)
        relations = [(u'ENTPersonFonctions', (['ORIENTATION'], ['ORIENTATION']))
                     ]
        keys = set(administratif.keys()) | set([u"userPassword", u"_id", u'uid', u'FieldFromXMLImportActionDate', u'id', u'FieldToLDIFFExportActionDate'])
        for relation in relations:
            keys |= set([relation[0]])
        log = logging.getLogger(__name__)
        #import complet AAF
        main(data_complet, False, allow_bulk=False, close=False)
        samba_import = SambaExport(log, debug=True)
        samba_import.run()
        #import delta AAF
        main(data_complet_maj, True, allow_bulk=False)
        samba_import = SambaExport(log, debug=True)
        samba_import.run()
        result = db.fetchall('user', 'UserType', 'administratif')
        list_administratifs = list(administratifs)
        for res in result:
            idx = res[u'ENTPersonJointure']
            if idx not in administratifs:
                continue
            print ("administratif " + idx + ' en mode ' + mode)
            list_administratifs.remove(idx)
            assert keys == set(res.keys())
            for key in administratif.keys():
                assert res[key] == administratifs[idx][key], u"la valeur correspondant à : {} est différente".format(key)
            for relation, values in relations:
                assert relation in res
                assert isinstance(res[relation]['etablissement'], ObjectId)
                assert res[relation]['function'] == values[0][0]
                assert res[relation]['discipline'] == values[1][0]
            # we test what is in the AD
            filter_ = "(&(sAMAccountName=%s)(objectCategory=%s,%s))" % (ldb.binary_encode(res['ENTPersonLogin']),
                      "CN=Person,CN=Schema,CN=Configuration", samba_import.samdb.domain_dn())
            target = samba_import.samdb.search(base=samba_import.samdb.domain_dn(), scope=ldb.SCOPE_SUBTREE,
                                 expression=filter_)
            query_result = list(target)
            list_keys = list(administratifs_ad[idx])
            for key, value in dict(query_result[0]).items():
                values = []
                if key in ['whenCreated', 'whenChanged', 'objectGUID', 'objectSid', 'accountExpires', 'sAMAccountType', 'pwdLastSet', 'uSNChanged', 'uSNCreated']:
                    continue
                if key not in list_keys:
                    raise Exception('unknown key {} with value {}'.format(key, value))
                list_keys.remove(key)
                if isinstance(value, ldb.Dn):
                    values.append(str(value))
                else:
                    for i in value:
                        values.append(str(i))
                assert set(values) == set(administratifs_ad[idx][key]), u"valeurs différentes pour la clef : {} en mode {}".format(key, mode)
            assert not list_keys
        assert list_administratifs == []


def test_eleves():
    ori_toplevel_ou_group = eoleaaf.config.toplevel_ou_group
    ori_toplevel_ou_user = eoleaaf.config.toplevel_ou_user
    for mode, eleves_ad, SambaExport in [('toplevel', eleves_ad_toplevel, sambatranslator.SambaToplevel), ('groupsplit', eleves_ad_groupsplit, sambatranslator.SambaGroupSplit), ('split', eleves_ad_split, sambatranslator.SambaSplit)]:
        if mode == 'toplevel':
            sambatranslator.toplevel_ou_group = ori_toplevel_ou_group
            sambatranslator.toplevel_ou_user = ori_toplevel_ou_user
        elif mode == 'groupsplit':
            sambatranslator.toplevel_ou_group = 'OU=Group'
            sambatranslator.toplevel_ou_user = ori_toplevel_ou_user
        else:  # mode == 'split'
            sambatranslator.toplevel_ou_group = ori_toplevel_ou_group
            sambatranslator.toplevel_ou_user = ori_toplevel_ou_user
        setup_function(None)
        objectids = ['ENTEleveParents', 'ENTElevePere', 'ENTEleveMere', 'ENTEleveAutoriteParentale', 'ENTPersonStructRattach']
        relations = [(u'ENTEleveClasses', ['etb1_T STL']),
                     (u"ENTPersonStructRattachsOld", ["4E3_A"]),
                ]
        keys = set(eleve.keys()) | set([u"userPassword", u"_id", u'uid', u'FieldFromXMLImportActionDate', u'id', u'FieldToLDIFFExportActionDate']) | set(objectids)
        for relation in relations:
            keys |= set([relation[0]])
        log = logging.getLogger(__name__)
        #import complet AAF
        main(data_complet, False, allow_bulk=False, close=False)
        samba_import = SambaExport(log, debug=True)
        samba_import.run()
        #import delta AAF
        main(data_complet_maj, True, allow_bulk=False)
        samba_import = SambaExport(log, debug=True)
        samba_import.run()
        result = db.fetchall('user', 'UserType', 'eleve')
        list_eleves = list(eleves)
        for res in result:
            idx = res[u'ENTEleveMEF']
            if idx not in eleves:
                continue
            print ("eleve " + idx + ' en mode ' + mode )
            list_eleves.remove(idx)
            # we test everything in mongodb
            assert keys == set(res.keys())
            for key in eleve.keys():
                if key == 'ENTEleveCodeEnseignements':
                    assert res[key][0] == u'010300'
                    assert isinstance(res[key][1], ObjectId)
                elif key == 'ENTEleveNivFormation':
                    assert res[key]['oriName'].split('_', 1)[1] == eleves[idx][key]
                else:
                    assert res[key] == eleves[idx][key], u"la valeur correspondant à : {} est différente".format(key)
            for objectid in objectids:
                values = res[objectid]
                if isinstance(values, list):
                    for val in values:
                        assert isinstance(val, ObjectId), u"{} n'est pas une relation".format(objectid)
                        #FIXME bon parent ?
                else:
                    assert isinstance(values, ObjectId), u"{} n'est pas une relation".format(objectid)

            # we test what is in the AD
            filter_ = "(&(sAMAccountName=%s)(objectCategory=%s,%s))" % (ldb.binary_encode(res['ENTPersonLogin']),
                      "CN=Person,CN=Schema,CN=Configuration", samba_import.samdb.domain_dn())
            target = samba_import.samdb.search(base=samba_import.samdb.domain_dn(), scope=ldb.SCOPE_SUBTREE,
                                 expression=filter_)
            query_result = list(target)
            assert len(query_result) == 1
            list_keys = list(eleves_ad[idx])
            for key, value in dict(query_result[0]).items():
                values = []
                if key in ['whenCreated', 'whenChanged', 'objectGUID', 'objectSid', 'accountExpires', 'sAMAccountType', 'pwdLastSet', 'uSNChanged', 'uSNCreated']:
                    continue
                if key not in list_keys:
                    raise Exception('unknown key {} with value {}'.format(key, value))
                list_keys.remove(key)
                if isinstance(value, ldb.Dn):
                    values.append(str(value))
                else:
                    for i in value:
                        values.append(str(i))
                assert set(values) == set(eleves_ad[idx][key]), u"valeurs différentes pour la clef : {} en mode {}".format(key, mode)
            assert not list_keys

    assert not list_eleves
